package org.dromara.system.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.system.domain.bo.SysRolePermissionBo;
import org.dromara.system.domain.vo.SysRolePermissionVo;

import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * 角色和菜单关联Service接口
 *
 * @author shihongwei
 * @date 2025-12-24
 */
public interface ISysRolePermissionService {

    /**
     * 查询角色和菜单关联
     *
     * @param roleId 主键
     * @return 角色和菜单关联
     */
    SysRolePermissionVo queryById(Long roleId);

    /**
     * 分页查询角色和菜单关联列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 角色和菜单关联分页列表
     */
    TableDataInfo<SysRolePermissionVo> queryPageList(SysRolePermissionBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的角色和菜单关联列表
     *
     * @param bo 查询条件
     * @return 角色和菜单关联列表
     */
    List<SysRolePermissionVo> queryList(SysRolePermissionBo bo);

    /**
     * 新增角色和菜单关联
     *
     * @param bo 角色和菜单关联
     * @return 是否新增成功
     */
    Boolean insertByBo(SysRolePermissionBo bo);

    /**
     * 修改角色和菜单关联
     *
     * @param bo 角色和菜单关联
     * @return 是否修改成功
     */
    Boolean updateByBo(SysRolePermissionBo bo);

    /**
     * 校验并批量删除角色和菜单关联信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    Set<String> getPermissionCodesByCompanyId(Long userId, Long companyId, String loginPort);

    public Set<String> getPermissionCodesByRoleId(Long roleId);
    /**
     * 根据角色ID查询选中菜单ID列表
     *
     * @param roleId 角色ID
     * @return 选中菜单ID列表
     */
    List<Long> selectMenuIdsByRoleId(Long roleId);
}
